# Synced from ballistica-master-server.
# EFRO_SYNC_HASH=332275170102764395151241726800066621596
#
# Copyright (c) 2011-2024 Eric Froemling
"""Request related functionality."""

from __future__ import annotations

from typing import TYPE_CHECKING, Protocol

if TYPE_CHECKING:
    pass


class ProvidesRequestAuthentication(Protocol):
    """Something that provides auth functionality."""

    @property
    def signed_in(self) -> bool:
        """Are we signed in?"""

    @property
    def session_id(self) -> str | None:
        """Our current session id."""

    @property
    def accountid(self) -> str:
        """Our account id (assumes we're signed in)."""

    @property
    def account_tag(self) -> str:
        """Our account tag (assumes we're signed in)."""

    @property
    def is_admin(self) -> bool:
        """Whether the current authorized user is an admin."""
