# Released under the MIT License. See LICENSE for details.
#
"""Auto-generated receiver module. Do not edit by hand."""

from __future__ import annotations

from typing import TYPE_CHECKING, overload

from efro.message import MessageReceiver, BoundMessageReceiver

if TYPE_CHECKING:
    from typing import Any, Callable, Awaitable
    from baserver.msg.bamastertobasn import (
        LogQueryMessage,
        ShutdownMessage,
        TestErrorMessage,
        UpdateAndRestartMessage,
        TaskTestMessage,
        TestCommMessage,
        InvalidateTokenMessage,
        TestAIOErrorMessage,
        ClearErrorsMessage,
        TestScratchMessage,
        PingMessage,
        TasksQueryMessage,
        TaskQueryMessage,
        SetRunModeMessage,
        WaitStateMessage,
        TestLogMessage,
        TestPrintMessage,
        HostGameMessage,
        TaskActionMessage,
        TaskRunningMessage,
        TaskKillMessage,
        ServerNodeSettingsMessage,
        HostPingTargetMessage,
        HostTransportAgentMessage,
        ForwardedToClientMessage,
        GetDebugInfoMessage,
        CloudConsoleUpdateMessage,
        ExecCloudBuildMessage,
        LogQueryResponse,
        ShutdownResponse,
        TasksQueryResponse,
        TaskQueryResponse,
        TaskActionResponse,
        HostGameResponse,
        HostPingTargetResponse,
        HostTransportAgentResponse,
        ForwardedToClientResponse,
        GetDebugInfoResponse,
        CloudConsoleUpdateResponse,
        ExecCloudBuildResponse,
    )
    from efro.message import BoolResponse


class BAMasterMessageReceiver(MessageReceiver):
    """Protocol-specific asynchronous receiver."""

    is_async = True

    def __init__(self) -> None:
        from baserver.msg.bamastertobasn import get_protocol

        protocol = get_protocol()
        super().__init__(protocol)

    def __get__(
        self,
        obj: Any,
        type_in: Any = None,
    ) -> BoundBAMasterMessageReceiver:
        return BoundBAMasterMessageReceiver(obj, self)

    @overload
    def handler(
        self,
        call: Callable[[Any, LogQueryMessage], Awaitable[LogQueryResponse]],
    ) -> Callable[[Any, LogQueryMessage], Awaitable[LogQueryResponse]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, ShutdownMessage], Awaitable[ShutdownResponse]],
    ) -> Callable[[Any, ShutdownMessage], Awaitable[ShutdownResponse]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, TestErrorMessage], Awaitable[None]],
    ) -> Callable[[Any, TestErrorMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, UpdateAndRestartMessage], Awaitable[None]],
    ) -> Callable[[Any, UpdateAndRestartMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, TaskTestMessage], Awaitable[None]],
    ) -> Callable[[Any, TaskTestMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, TestCommMessage], Awaitable[None]],
    ) -> Callable[[Any, TestCommMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, InvalidateTokenMessage], Awaitable[None]],
    ) -> Callable[[Any, InvalidateTokenMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, TestAIOErrorMessage], Awaitable[None]],
    ) -> Callable[[Any, TestAIOErrorMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, ClearErrorsMessage], Awaitable[None]],
    ) -> Callable[[Any, ClearErrorsMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, TestScratchMessage], Awaitable[None]],
    ) -> Callable[[Any, TestScratchMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, PingMessage], Awaitable[None]],
    ) -> Callable[[Any, PingMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, TasksQueryMessage], Awaitable[TasksQueryResponse]],
    ) -> Callable[[Any, TasksQueryMessage], Awaitable[TasksQueryResponse]]: ...

    @overload
    def handler(
        self,
        call: Callable[
            [Any, TaskQueryMessage], Awaitable[TaskQueryResponse | None]
        ],
    ) -> Callable[
        [Any, TaskQueryMessage], Awaitable[TaskQueryResponse | None]
    ]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, SetRunModeMessage], Awaitable[None]],
    ) -> Callable[[Any, SetRunModeMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, WaitStateMessage], Awaitable[None]],
    ) -> Callable[[Any, WaitStateMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, TestLogMessage], Awaitable[None]],
    ) -> Callable[[Any, TestLogMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, TestPrintMessage], Awaitable[None]],
    ) -> Callable[[Any, TestPrintMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, HostGameMessage], Awaitable[HostGameResponse]],
    ) -> Callable[[Any, HostGameMessage], Awaitable[HostGameResponse]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, TaskActionMessage], Awaitable[TaskActionResponse]],
    ) -> Callable[[Any, TaskActionMessage], Awaitable[TaskActionResponse]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, TaskRunningMessage], Awaitable[BoolResponse]],
    ) -> Callable[[Any, TaskRunningMessage], Awaitable[BoolResponse]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, TaskKillMessage], Awaitable[None]],
    ) -> Callable[[Any, TaskKillMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, ServerNodeSettingsMessage], Awaitable[None]],
    ) -> Callable[[Any, ServerNodeSettingsMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[
            [Any, HostPingTargetMessage], Awaitable[HostPingTargetResponse]
        ],
    ) -> Callable[
        [Any, HostPingTargetMessage], Awaitable[HostPingTargetResponse]
    ]: ...

    @overload
    def handler(
        self,
        call: Callable[
            [Any, HostTransportAgentMessage],
            Awaitable[HostTransportAgentResponse],
        ],
    ) -> Callable[
        [Any, HostTransportAgentMessage], Awaitable[HostTransportAgentResponse]
    ]: ...

    @overload
    def handler(
        self,
        call: Callable[
            [Any, ForwardedToClientMessage],
            Awaitable[ForwardedToClientResponse],
        ],
    ) -> Callable[
        [Any, ForwardedToClientMessage], Awaitable[ForwardedToClientResponse]
    ]: ...

    @overload
    def handler(
        self,
        call: Callable[
            [Any, GetDebugInfoMessage], Awaitable[GetDebugInfoResponse]
        ],
    ) -> Callable[
        [Any, GetDebugInfoMessage], Awaitable[GetDebugInfoResponse]
    ]: ...

    @overload
    def handler(
        self,
        call: Callable[
            [Any, CloudConsoleUpdateMessage],
            Awaitable[CloudConsoleUpdateResponse],
        ],
    ) -> Callable[
        [Any, CloudConsoleUpdateMessage], Awaitable[CloudConsoleUpdateResponse]
    ]: ...

    @overload
    def handler(
        self,
        call: Callable[
            [Any, ExecCloudBuildMessage], Awaitable[ExecCloudBuildResponse]
        ],
    ) -> Callable[
        [Any, ExecCloudBuildMessage], Awaitable[ExecCloudBuildResponse]
    ]: ...

    def handler(self, call: Callable) -> Callable:
        """Decorator to register message handlers."""
        self.register_handler(call)
        return call


class BoundBAMasterMessageReceiver(BoundMessageReceiver):
    """Protocol-specific bound receiver."""

    def handle_raw_message(
        self, message: str, raise_unregistered: bool = False
    ) -> Awaitable[str]:
        """Asynchronously handle a raw incoming message."""
        return self._receiver.handle_raw_message_async(
            self._obj, message, raise_unregistered
        )
