# Released under the MIT License. See LICENSE for details.
#
"""Auto-generated receiver module. Do not edit by hand."""

from __future__ import annotations

from typing import TYPE_CHECKING, overload

from efro.message import MessageReceiver, BoundMessageReceiver

if TYPE_CHECKING:
    from typing import Any, Callable, Awaitable
    from bacommon.cloud import (
        LoginProxyRequestMessage,
        LoginProxyStateQueryMessage,
        LoginProxyCompleteMessage,
        SignInMessage,
        LoginProxyRequestResponse,
        LoginProxyStateQueryResponse,
        WorkspaceFetchResponse,
        PingResponse,
        SignInResponse,
        ManageAccountResponse,
        MerchAvailabilityResponse,
        PromoCodeResponse,
    )
    from baserver.msg.batocloud import (
        CToBMsg1,
        CToBMsg2,
        AccountSessionReleaseMessage,
        CredentialsCheckMessage,
        AccountChannelCreateMessage,
        AccountChannelDestroyMessage,
        CToBResp1,
        CToBResp2,
        CredentialsCheckResponse,
        PostLoginResponse,
    )


class ClientMessageReceiver(MessageReceiver):
    """Protocol-specific asynchronous receiver."""

    is_async = True

    def __init__(self) -> None:
        from baserver.msg.batocloud import get_ba_to_cloud_protocol_basn

        protocol = get_ba_to_cloud_protocol_basn()
        super().__init__(protocol)

    def __get__(
        self,
        obj: Any,
        type_in: Any = None,
    ) -> BoundClientMessageReceiver:
        return BoundClientMessageReceiver(obj, self)

    @overload
    def handler(
        self,
        call: Callable[[Any, CToBMsg1], Awaitable[CToBResp1]],
    ) -> Callable[[Any, CToBMsg1], Awaitable[CToBResp1]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, CToBMsg2], Awaitable[CToBResp1 | CToBResp2]],
    ) -> Callable[[Any, CToBMsg2], Awaitable[CToBResp1 | CToBResp2]]: ...

    @overload
    def handler(
        self,
        call: Callable[
            [Any, LoginProxyRequestMessage],
            Awaitable[LoginProxyRequestResponse],
        ],
    ) -> Callable[
        [Any, LoginProxyRequestMessage], Awaitable[LoginProxyRequestResponse]
    ]: ...

    @overload
    def handler(
        self,
        call: Callable[
            [Any, LoginProxyStateQueryMessage],
            Awaitable[LoginProxyStateQueryResponse],
        ],
    ) -> Callable[
        [Any, LoginProxyStateQueryMessage],
        Awaitable[LoginProxyStateQueryResponse],
    ]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, LoginProxyCompleteMessage], Awaitable[None]],
    ) -> Callable[[Any, LoginProxyCompleteMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, AccountSessionReleaseMessage], Awaitable[None]],
    ) -> Callable[[Any, AccountSessionReleaseMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[
            [Any, CredentialsCheckMessage], Awaitable[CredentialsCheckResponse]
        ],
    ) -> Callable[
        [Any, CredentialsCheckMessage], Awaitable[CredentialsCheckResponse]
    ]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, AccountChannelCreateMessage], Awaitable[None]],
    ) -> Callable[[Any, AccountChannelCreateMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, AccountChannelDestroyMessage], Awaitable[None]],
    ) -> Callable[[Any, AccountChannelDestroyMessage], Awaitable[None]]: ...

    @overload
    def handler(
        self,
        call: Callable[[Any, SignInMessage], Awaitable[SignInResponse]],
    ) -> Callable[[Any, SignInMessage], Awaitable[SignInResponse]]: ...

    def handler(self, call: Callable) -> Callable:
        """Decorator to register message handlers."""
        self.register_handler(call)
        return call


class BoundClientMessageReceiver(BoundMessageReceiver):
    """Protocol-specific bound receiver."""

    def handle_raw_message(
        self, message: str, raise_unregistered: bool = False
    ) -> Awaitable[str]:
        """Asynchronously handle a raw incoming message."""
        return self._receiver.handle_raw_message_async(
            self._obj, message, raise_unregistered
        )
