"""Wrangle transport connection to a client."""

from __future__ import annotations

import asyncio

from typing import TYPE_CHECKING

from baserver.msg import cloudtoba
from baserver.msg import batocloud

from basn.logging import logextra

if TYPE_CHECKING:
    from basn.taskwrapper.transportagent import (
        TransportAgentTaskWrapper,
    )


async def endpoint_test(self: TransportAgentTaskWrapper) -> None:
    """Testing sending some messages TO the client."""
    print('SENDING TEST MESSAGES TO CLIENT')
    try:
        response = await self.msg_out.send_async(cloudtoba.BToCMsg1(ival=123))
        print(f'GOT RESPONSE FROM CLIENT {response}!!!')
        response2 = await self.msg_out.send_async(
            cloudtoba.BToCMsg2(sval='poo')
        )
        print(f'GOT RESPONSE2 FROM CLIENT {response2}!!!')
    except Exception:
        self.logger.exception('Error on send', extra=logextra(task=self))


async def handle_msg_2(
    self: TransportAgentTaskWrapper, msg: batocloud.CToBMsg2
) -> batocloud.CToBResp1 | batocloud.CToBResp2:
    """Message handling internals."""
    print(f'HANDLING2 {msg}!!!!!!!!!')

    # Run some tests of sending messages back to the client.
    # NOTE - this may be lost since we aren't grabbing ref.
    self.tasks.append(asyncio.create_task(endpoint_test(self), name='msgtest'))

    return batocloud.CToBResp1(bval=True)
